<?php
add_action('wp_ajax_rw_api_data', 'rw_api_data');
    function rw_api_data(){
	   if ( isset($_POST["vin"]) && strlen($_POST["vin"]) === 17 ){
		$vin = $_POST["vin"];
		$url = "https://vpic.nhtsa.dot.gov/api/vehicles/decodevinvalues/".$vin."?format=json";
        $get_response = wp_remote_get($url);
        if( !is_wp_error( $get_response ) ) :
            $basic_data1 = json_decode( $get_response['body'], TRUE);
			$basic_data=$basic_data1['Results'][0];
            $post_id = (int)$_POST["ID"];
            if( strpos($basic_data['ErrorCode'],'VIN decoded clean') ) :
                $elements = array();       
                $elements["year"] = $basic_data['ModelYear'];
                $elements['Make'] = $basic_data["Make"];
                $elements['Model'] = $basic_data["Model"];				
                $elements["vehicletype"] = array( str_replace('Cabriolet/Convertible','Convertible',$basic_data["BodyClass"]), str_replace('Sedan/Saloon','Sedan',$basic_data["BodyClass"]),  str_replace('Crossover Utility Vehicle (CUV)','Crossover',$basic_data["BodyClass"]),str_replace('Sport Utility Vehicle (SUV)/Multi Purpose Vehicle (MPV)','Sport Utility',$basic_data["BodyClass"]),$elements["vehicletype"] = str_replace('Incomplete - ','',$basic_data["BodyClass"])); 
                		switch( strtoupper($basic_data["TransmissionStyle"]) ) :
                			case "AUTOMATIC" :
                				$elements['transmission'] = 'Automatic';
                			break;
                			case "MANUAL" :
                				$elements['transmission'] = 'Manual';
                			break;
                			case "SEMI-AUTO" :
                				$elements['transmission'] = 'Semi-Auto';
                			break;
                			default :
                				$elements['transmission'] = 'Other';
                			break;
                		endswitch;                   
                        $tags_relations = array(            
                            "Airbags" => array(
                                "Side Airbags" => "name",
                                "Passenger Airbag" => "name",
                                "Head Airbags" => "name",
                                "Knee Airbags" => "name",
                                "Hip Airbags" => "name"
                            ),
                            "Air Conditioning" => array(
                                "Front Air Conditioning" => "ac",
                                "Air Filtration" => "name",
                                "Sun Sensor" => "name"
                            ),
                            "Audio System" => array(
                                "Cd Player" => "name",
                                "Cd Mp3 Playback" => "mp3",
                                "Radio" => "radio",
                                "Satellite Radio" => "name",
                                "Usb Connection" => "name"
                            ),
                            "Brake System" => array(
                                "Antilock Braking System" => "abs",
                                "Braking Assist" => "name",
                                "Brake Drying" => "name",
                                "Emergency Braking Preparation" => "name"
                            ),
                            "Convertible Roof" => array(
                                "Convertible Roof" => "name",
                                "Convertible Window" => "name"
                            ),
                            "Doors" => array(
                                "Number Of Doors" => "num_doors"
                            ),
                            "Driver Seat" => array(
                                "Heated Driver Seat" => "name",
                                "Height Adjustable Driver Seat" => "name"
                            ),
                            "Drive Type" => array(
                                "Driven Wheels" => "driven_wheels"
                            ),
                            "Exterior Lights" => array(
                                "Front Fog Lights" => "name",
                                "Headlights Auto Delay" => "had",
                                "Daytime Running Lights" => "name",
                                "Headlights Dusk Sensor" => "name"
                            ),
                            "Front Passenger Seat" => array(
                                "Heated Passenger Seat" => "name"
                            ),
                            "Instrumentation" => array(
                                "Tachometer" => "name",
                                "Low Fuel Level Indicator" => "name",
                                "Tire Pressure Monitoring System" => "name",
                                "Compass" => "name",
                                "External Temperature Gauge" => "name",
                                "Head Up Display" => "name",
                                "Trip Computer" => "name",
                                "Transmission Temperature Gauge" => "name"
                            ),
                            "Misc. Exterior Features" => array(
                                "Rear Spoiler" => "name"
                            ),
                            "Misc. Interior Features" => array(
                                "Cruise Control" => "name",
                                "Cargo Area Light" => "name",
                                "Reading Lights" => "name"
                            ),
                            "Mirrors" => array(
                                "Heated Exterior Mirrors" => "name",
                                "Heated Passenger Side Mirror" => "name",
                                "Auto Dimming Rearview Mirror" => "name",
                                "Auto Dimming Side Mirrors" => "name"
                            ),
                            "Mobile Connectivity" => array(
                                "Phone" => "name",
                                "Bluetooth" => "name"
                            ),
                            "Parking Aid" => array(
                                "Parking Sensors" => "name"
                            ),
                            "Security" => array(
                                "Engine Immobilizer" => "name",
                                "Anti Theft Alarm System" => "alarm",
                                "Power Door Locks" => "door_locks",
                                "2 Stage Unlocking" => "name"
                            ),
                            "Spare Tire/Wheel" => array(
                                "Tire Repair Kit" => "name"
                            ),
                            "Standard Audio" => array(
                                "Cd Player" => "name",
                                "Cd Mp3 Playback" => "mp3",
                                "Radio" => "radio",
                                "Satellite Radio" => "name",
                                "Usb Connection" => "name"
                            ),
                            "Steering Wheel" => array(
                                "Audio Controls On Steering Whee" => "name",
                                "Phone Controls On Steering Whee" => "name"
                            ),
                            "Sunroof" => array(
                                "Sunroof" => "name"
                            ),
                            "Windows" => array(
                                "Rear Defogger" => "name",
                                "Rain Sensing Front Wipers" => "name",
                                "Remote Window Operation" => "name"
                            )
                        );
                        $tags = array();                        $existing_element_array=array('Model','Make','ModelYear','VehicleType','TransmissionStyle');
						
						foreach($basic_data as $key=>$value)
						{
							if(!in_array($key,$existing_element_array))
							{
								$elements[$key] = $value;
							}
						}
                		$elements['post_name'] = $basic_data["Model"];
                		$elements['post_title'] = $elements["year"].' '. $elements['Make'] . ' '.$elements['Model'];

                        $response["tags"] = join(",",$tags);                   
                        $makemodel_terms = array();
                        $make_term = term_exists( $basic_data["Make"] , 'makemodel' , 0 );
                        if( $make_term !== 0 && $make_term !== null ) :
                            $makemodel_terms[] = (int)$make_term["term_id"];
                        else :
                            $make_term = wp_insert_term( $basic_data["Make"] , 'makemodel');
                            if( !is_wp_error( $make_term ) ) :

                                $makemodel_terms[] = (int)$make_term["term_id"];
                            endif;
                        endif;
                        $model_term = term_exists( $basic_data["Model"] , 'makemodel' , $make_term["term_id"] );
                        if( $model_term !== 0 && $model_term !== null ) :
                            $makemodel_terms[] = (int)$model_term["term_id"];
                        else :  
                            $model_term = wp_insert_term( $basic_data["Model"] , 'makemodel', array( "parent" => $make_term["term_id"] ));
                            if( !is_wp_error( $model_term ) ) :
                                $makemodel_terms[] = $model_term["term_id"];
                            endif;
                        endif;
                        wp_set_object_terms( $post_id, $makemodel_terms, 'makemodel' );
                        ob_start();
                        wp_terms_checklist( $post_id, array( 'taxonomy' => 'makemodel', 'popular_cats' => wp_popular_terms_checklist( 'makemodel' , "" , 10, false ) ) );
                        $elements["makemodelchecklist"] = ob_get_clean();
                        ob_start();
                        wp_popular_terms_checklist( 'makemodel' );
                        $elements["makemodelchecklist-pop"] = ob_get_clean();
                        $response["elements"] = $elements;
                        $response["error"] = false;
            else :
                $response["error"] = true;
                $response["error_message"] = $basic_data["ErrorCode"];

            endif;
        else :
            $response["error"] = true;
            $response["error_message"] = $get_response->get_error_message();
        endif;
        header("Content-Type:application/json");
		echo json_encode($response);
		die();
	}
}
?>